<script lang="ts">
import Vue from 'vue';
import SolutionsVideoModal from './video-modal.vue';
import { UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'SolutionsResourcesVideoCard',
  components: {
    SolutionsVideoModal,
  },
  mixins: [UseLocalizedVideoSubtitles],
  props: {
    cardData: {
      type: Object,
      required: true,
      default: null,
    },
    fromGitLabDuo: {
      // changes styling, should be refactored in the future
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      modalIsOpen: false,
    };
  },
  methods: {
    openModal() {
      this.modalIsOpen = true;

      if (!this.fromGitLabDuo) {
        // fixes broken analytics on GitLab Duo page
        setTimeout(() => {
          window.__vimeoRefresh();
        }, 3000);
      }
    },
  },
});
</script>

<template>
  <div
    class="resources-card-video-card"
    :class="{ 'gitlab-duo': fromGitLabDuo }"
  >
    <div class="resources-card-video-card__wrapper">
      <div class="resources-card-video-card__content-top">
        <div class="resources-card-video-card__icon slp-flex">
          <SlpIcon
            v-if="cardData.icon"
            :name="cardData.icon.name"
            :variant="cardData.icon.variant"
            :alt="cardData.icon.alt"
            slp-color="text-300"
          />
          <SlpTypography
            tag="p"
            variant="body2"
            class="resources-card-video-card__type"
            >{{ cardData.event_type }}
          </SlpTypography>
        </div>
        <div
          class="slp-my-24 resources-card-video-card__image"
          @click="openModal()"
        >
          <img
            class=""
            :src="
              cardData.image ||
              cardData.fallback_image ||
              '/nuxt-images/resources/fallback/img-fallback-cards-infinity.png'
            "
            alt=""
            loading="lazy"
          />
          <SlpButton
            variant="ghost"
            class="resources-card-video-card__video-button"
          >
            <SlpIcon
              v-if="!fromGitLabDuo"
              class="resources-card-video-card__icon"
              name="play-circle"
              variant="marketing"
              size="lg"
              slp-color="text-primary-200"
            />
          </SlpButton>
        </div>

        <SlpTypography tag="h3" variant="body1" class=""
          >{{ cardData.header }}
        </SlpTypography>
      </div>
      <div v-if="cardData.text" class="resources-card-video-card__content-text">
        <SlpTypography variant="body1">{{ cardData.text }}</SlpTypography>
      </div>
      <div class="resources-card-video-card__content-bottom">
        <SlpTypography
          variant="button"
          tag="span"
          class="resources-card-video-card__link"
          @click.native="openModal()"
          >{{ cardData.link_text }}
          <SlpIcon variant="product" name="chevron-lg-right" />
        </SlpTypography>
      </div>
    </div>

    <SolutionsVideoModal
      v-show="modalIsOpen"
      light-background
      :visible="modalIsOpen"
      @close="modalIsOpen = false"
    >
      <template #body>
        <!-- Use Embed video url -->
        <iframe
          ref="video"
          :src="createVideoSource(cardData.href)"
          title="Video player"
          class="resources-card-video-card__modal-video"
          allow="accelerometer; clipboard-write; encrypted-media; gyroscope; picture-in-picture"
          allowfullscreen
        ></iframe>
      </template>
    </SolutionsVideoModal>
  </div>
</template>

<style lang="scss" scoped>
.resources-card-video-card {
  display: flex;
  position: relative;
  height: 100%;
  min-width: 300px;

  @media (min-width: $breakpoint-md) {
    margin: $spacing-16 $spacing-16 $spacing-16 0;
  }

  &.gitlab-duo {
    color: $color-text-50;

    .resources-card-video-card__wrapper {
      .resources-card-video-card__link,
      .resources-card-video-card__content-text,
      .resources-card-video-card__content-top p,
      .resources-card-video-card__content-top h3 {
        color: $color-text-50;
      }

      &:hover {
        background: #ffffff0d;
      }
    }
  }

  &__wrapper {
    display: flex;
    flex-direction: column;
    transition: all 0.3s ease-in-out;
    justify-content: space-between;
    padding: $spacing-32 $spacing-16;
    flex: 1;

    @media (max-width: $breakpoint-md) {
      padding: $spacing-32 0;
    }

    .slp-icon {
      transition: margin-left 0.2s ease-in-out;
      margin-left: 4px;
    }
    &:hover {
      background: $color-surface-900;
      border-bottom-right-radius: 100px;
      .resources-card-video-card__video-button {
        fill: $color-text-link-100;
        color: $color-text-link-100;
      }

      .slp-icon {
        margin-left: 8px;
      }
    }
  }

  &__image {
    position: relative;
    cursor: pointer;
    img {
      width: 100%;
      object-fit: cover;
      object-position: 25% 0;
    }
  }

  &__link {
    color: $color-text-300;
    padding-top: $spacing-32;
    padding-left: 0;
    display: flex;
    align-items: center;
    cursor: pointer;

    @media (min-width: $breakpoint-lg) {
      padding-top: 0;
    }
  }

  &__type {
    margin-left: $spacing-8;
  }

  &__content-text {
    color: $color-text-300;
  }

  &__content-top {
    p,
    h3 {
      color: $color-text-300;
    }
  }

  .slp-text-button,
  .slp-btn-ghost {
    font-weight: 600;
  }

  &__video-button {
    position: absolute;
    opacity: 0.75;
    top: 0;
    bottom: 0;
    left: 50%;
    transform: translateX(-50%);
    transition: all 0.3s ease;
  }

  &__modal-video {
    border-radius: $border-radius-4;
    border: none;
    width: 330px;
    height: 200px;
    @media (min-width: $breakpoint-md) {
      width: 700px;
      height: 390px;
    }
    @media (min-width: $breakpoint-lg) {
      width: 920px;
      height: 516px;
    }
  }
}
</style>
